#!/usr/bin/env python

if __name__ == "__main__":
    import sys, os
    sys.setrecursionlimit(10000)

    from simplify import simplified

    if "-s" in sys.argv:
        simplified.set_single_instance_mode()
    elif "-m" in sys.argv:
        simplified.set_multiple_instance_mode()
    elif "-ms" in sys.argv:
        simplified.set_selective_multiple_instance_mode()
    elif "-mp" in sys.argv:
        simplified.set_prolific_multiple_instance_mode()

    import simplify.viewer
    from simplify import Importer
    import simplify.generator

    importer = Importer(["lib"] + sys.path, "-na" not in sys.argv)
    builtins = importer.load_from_file(os.path.join("lib", "builtins.py"))
    module = importer.load_from_file(sys.argv[1], builtins)
    if "-i" in sys.argv:
        importer.fix_instances()
    if "-d" in sys.argv:
        simplify.viewer.makedocs(sys.argv[1], importer.get_modules(), distinct=("-i" in sys.argv))
    if "-g" in sys.argv:
        code = simplify.generator.generate(module)
        code.dump()

# vim: tabstop=4 expandtab shiftwidth=4
